/****************************************************************************
 *    lib/b/ExecutableRule.h - This file is part of coala					*
 *																			*
 *    Copyright (C) 2009-2010  Torsten Grote								*
 *																			*
 *    This program is free software; you can redistribute it and/or modify	*
 *    it under the terms of the GNU General Public License as published by	*
 *    the Free Software Foundation; either version 3 of the License, or		*
 *    (at your option) any later version.									*
 *																			*
 *    This program is distributed in the hope that it will be useful,		*
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			*
 *    GNU General Public License for more details.							*
 *																			*
 *    You should have received a copy of the GNU General Public License		*
 *    along with this program; if not, see http://www.gnu.org/licenses		*
 ****************************************************************************/


#ifndef EXECUTABLERULE_H
#define EXECUTABLERULE_H
#include "../c/Statement.h"

#include <string>
#include <set>

namespace B {

using namespace C;

class ExecutableRule : virtual public C::Statement
{
public:
	ExecutableRule(int line, Formula* A, Formula* F, Types* types=NULL);
	
	virtual ~ExecutableRule ( );

	void print(Printer* p);

protected:
	Formula* A_;
	Formula* F_;

};

}; // end of package namespace

#endif // EXECUTABLERULE_H
