/****************************************************************************
 *    lib/c/DynamicRule.h - This file is part of coala						*
 *																			*
 *    Copyright (C) 2009  Torsten Grote										*
 *																			*
 *    This program is free software; you can redistribute it and/or modify	*
 *    it under the terms of the GNU General Public License as published by	*
 *    the Free Software Foundation; either version 3 of the License, or		*
 *    (at your option) any later version.									*
 *																			*
 *    This program is distributed in the hope that it will be useful,		*
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			*
 *    GNU General Public License for more details.							*
 *																			*
 *    You should have received a copy of the GNU General Public License		*
 *    along with this program; if not, see http://www.gnu.org/licenses		*
 ****************************************************************************/


#ifndef DYNAMICRULE_H
#define DYNAMICRULE_H
#include "StaticRule.h"

#include <string>

namespace C {

class DynamicRule : public StaticRule
{
public:
	DynamicRule(int line, Formula* F, Formula* G, Formula* H, Types* types=NULL);

	virtual ~DynamicRule ( );

	void printDirect(Printer* p);
	void printNonDirect(Printer* p);

protected:
	Formula* H_;

};
}; // end of package namespace

#endif // DYNAMICRULE_H
