/****************************************************************************
 *    lib/c/Function.h - This file is part of coala							*
 *																			*
 *    Copyright (C) 2009  Torsten Grote										*
 *																			*
 *    This program is free software; you can redistribute it and/or modify	*
 *    it under the terms of the GNU General Public License as published by	*
 *    the Free Software Foundation; either version 3 of the License, or		*
 *    (at your option) any later version.									*
 *																			*
 *    This program is distributed in the hope that it will be useful,		*
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			*
 *    GNU General Public License for more details.							*
 *																			*
 *    You should have received a copy of the GNU General Public License		*
 *    along with this program; if not, see http://www.gnu.org/licenses		*
 ****************************************************************************/


#ifndef FUNCTION_H
#define FUNCTION_H
#include "Term.h"

#include <string>

namespace C {

class Function : virtual public Term
{
public:
	Function(string* name, vector<Term*>* terms);

	virtual ~Function ( );
	
	set<Variable*>* getVariables();

private:
	vector<Term*> terms_;
	string name_;

};
}; // end of package namespace

#endif // FUNCTION_H
