/****************************************************************************
 *    lib/c/Interval.cpp - This file is part of coala						*
 *																			*
 *    Copyright (C) 2009  Torsten Grote										*
 *																			*
 *    This program is free software; you can redistribute it and/or modify	*
 *    it under the terms of the GNU General Public License as published by	*
 *    the Free Software Foundation; either version 3 of the License, or		*
 *    (at your option) any later version.									*
 *																			*
 *    This program is distributed in the hope that it will be useful,		*
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			*
 *    GNU General Public License for more details.							*
 *																			*
 *    You should have received a copy of the GNU General Public License		*
 *    along with this program; if not, see http://www.gnu.org/licenses		*
 ****************************************************************************/

#include "Interval.h"

using namespace C;

Interval::Interval(Constant* num1, Constant* num2) {
	from_ = num1;
	to_ = num2;
	text_ = from_->getText()+".."+to_->getText();
}

Interval::Interval(Constant* num, Variable* var) {
	from_ = num;
	to_ = var;
	text_ = from_->getText()+".."+to_->getText();
}

Interval::Interval(Variable* var, Constant* num) {
	from_ = var;
	to_ = num;
	text_ = from_->getText()+".."+to_->getText();
}

Interval::Interval(Variable* var1, Variable* var2) {
	from_ = var1;
	to_ = var2;
	text_ = from_->getText()+".."+to_->getText();
}

Interval::~Interval ( ) { }

set<Variable*>* Interval::getVariables() {
	set<Variable*>* vars = new set<Variable*>();
		//from_->getVariables();
//	if(!to_->getVariables().empty())
//		vars.push_back(to_->getVariables().at(0));

	return vars;
}
