/****************************************************************************
 *    lib/c/Printer.h - This file is part of coala							*
 *																			*
 *    Copyright (C) 2009  Torsten Grote										*
 *																			*
 *    This program is free software; you can redistribute it and/or modify	*
 *    it under the terms of the GNU General Public License as published by	*
 *    the Free Software Foundation; either version 3 of the License, or		*
 *    (at your option) any later version.									*
 *																			*
 *    This program is distributed in the hope that it will be useful,		*
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			*
 *    GNU General Public License for more details.							*
 *																			*
 *    You should have received a copy of the GNU General Public License		*
 *    along with this program; if not, see http://www.gnu.org/licenses		*
 ****************************************************************************/


#ifndef printer_h
#define printer_h

#include <string>
#include <vector>
#include <iostream>
#include <sstream>

using namespace std;

namespace C {

class Printer
{
public:
	Printer(ostream *output_stream, int, bool, bool, bool, bool, bool, string);

	virtual ~Printer();

	void add(string text);
	void addExtra(string text);
	void setSection(char);
	void print();
	void printLTLAuxilliaries();
	void printIncLTLAuxilliaries();

	int debug;
	bool fake_neg;
	bool inc;
	bool rev;
	bool no_w_chk;
	bool no_direct_enc;
	string lang;
	string neg;
	string T;

protected:
	virtual void printEncoding();
	void printBackwardsEncoding();
	char section_;
	ostream* o;
	stringstream b;
	stringstream c;
	stringstream v;
	stringstream extra;
	bool printed_ltl_aux_;

};
}; // end of package namespace

#endif // PRINTER_H
