/****************************************************************************
 *    lib/c/Type.h - This file is part of coala								*
 *																			*
 *    Copyright (C) 2009  Torsten Grote										*
 *																			*
 *    This program is free software; you can redistribute it and/or modify	*
 *    it under the terms of the GNU General Public License as published by	*
 *    the Free Software Foundation; either version 3 of the License, or		*
 *    (at your option) any later version.									*
 *																			*
 *    This program is distributed in the hope that it will be useful,		*
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			*
 *    GNU General Public License for more details.							*
 *																			*
 *    You should have received a copy of the GNU General Public License		*
 *    along with this program; if not, see http://www.gnu.org/licenses		*
 ****************************************************************************/


#ifndef TYPE_H
#define TYPE_H

#include <string>
#include <vector>
#include "Identifier.h"
#include "Arguments.h"

#include <iostream>
namespace C {

class Type : public Identifier
{
public:
	Type(string* name, Arguments* args, bool sign);
	virtual ~Type();
	
	void setMin(int);
	void setMax(int);
	int getMin();
	int getMax();
	bool isTrue();

	string print(Printer*);
private:
	bool sign_;
};
}; // end of package namespace

#endif // TYPE_H
